Index: /trunk/sources/HeuristicLab.Clients.Access/3.3/ServiceClients/GenerateServiceClients.cmd
===================================================================
--- /trunk/sources/HeuristicLab.Clients.Access/3.3/ServiceClients/GenerateServiceClients.cmd	(revision 14725)
+++ /trunk/sources/HeuristicLab.Clients.Access/3.3/ServiceClients/GenerateServiceClients.cmd	(revision 14726)
@@ -1,30 +1,52 @@
-echo off
+@ECHO OFF
 
-echo.
-echo *******************************************************************************************
-echo Generating AccessService client
-echo.
+SET HOST=
+SET GENERATECONFIG=
 
-svcutil.exe ^
-  http://localhost:81/AccessService?wsdl ^
-  /out:AccessServiceClient ^
-  /namespace:*,HeuristicLab.Clients.Access ^
-  /collectionType:System.Collections.Generic.List`1 ^
-  /targetClientVersion:Version35 ^
-  /serializable ^
-  /enableDataBinding ^
-  /config:..\app.config 
+ECHO.
+ECHO *******************************************************************************************
 
-echo.
-echo ---------------------------------------------------------------------------------------
-echo !!! ATTENTION !!! ATTENTION !!! ATTENTION !!! ATTENTION !!! ATTENTION !!! ATTENTION !!!
-echo.
-echo Following modifications have to be done manually in generated data contracts:
-echo  * Remove method "protected void RaisePropertyChanged(string propertyName)" in AccessServiceItem
-echo.
-echo !!! ATTENTION !!! ATTENTION !!! ATTENTION !!! ATTENTION !!! ATTENTION !!! ATTENTION !!!
-echo ---------------------------------------------------------------------------------------
-echo.
-echo Generation of AccessService client finished.
-echo *******************************************************************************************
+SET /P HOST=Which host should be used? [services.heuristiclab.com]: 
+IF "%HOST%"=="" SET HOST=services.heuristiclab.com
 
+SET /P GENERATECONFIG=Would you like to generate the configuration file? [y]: 
+IF "%GENERATECONFIG%"=="" SET GENERATECONFIG=y
+
+SET ARGS=http://%HOST%/AccessService-3.3/AccessService.svc?wsdl ^
+/out:AccessServiceClient ^
+/namespace:*,HeuristicLab.Clients.Access ^
+/collectionType:System.Collections.Generic.List`1 ^
+/targetClientVersion:Version35 ^
+/serializable ^
+/enableDataBinding ^
+/syncOnly
+
+IF "%GENERATECONFIG%"=="y" (
+  SET ARGS=%ARGS% /config:..\app.config /mergeConfig
+) ELSE (
+  SET ARGS=%ARGS% /noConfig
+)
+
+ECHO.
+ECHO Generating AccessService client
+ECHO.
+
+SETLOCAL ENABLEDELAYEDEXPANSION
+svcutil.exe %ARGS%
+ENDLOCAL
+
+ECHO.
+ECHO ---------------------------------------------------------------------------------------
+ECHO !!! ATTENTION !!! ATTENTION !!! ATTENTION !!! ATTENTION !!! ATTENTION !!! ATTENTION !!!
+ECHO.
+ECHO Following modifications have to be done manually in generated data contracts:
+ECHO  * Remove method "protected void RaisePropertyChanged(string propertyName)" in generated AccessItem
+ECHO.
+ECHO !!! ATTENTION !!! ATTENTION !!! ATTENTION !!! ATTENTION !!! ATTENTION !!! ATTENTION !!!
+ECHO ---------------------------------------------------------------------------------------
+ECHO.
+ECHO Generation of AccessService client finished.
+ECHO *******************************************************************************************
+ECHO.
+
+PAUSE
Index: /trunk/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/GenerateServiceClients.cmd
===================================================================
--- /trunk/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/GenerateServiceClients.cmd	(revision 14725)
+++ /trunk/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/GenerateServiceClients.cmd	(revision 14726)
@@ -1,30 +1,52 @@
-echo off
+@ECHO OFF
 
-echo.
-echo *******************************************************************************************
-echo Generating HiveService client
-echo.
+SET HOST=
+SET GENERATECONFIG=
 
-svcutil.exe ^
-  http://localhost/Hive-3.3/HiveService.svc?wsdl ^
-  /out:HiveServiceClient ^
-  /namespace:*,HeuristicLab.Clients.Hive ^
-  /collectionType:System.Collections.Generic.List`1 ^
-  /targetClientVersion:Version35 ^
-  /serializable ^
-  /enableDataBinding ^
-  /config:..\app.config 
+ECHO.
+ECHO *******************************************************************************************
 
-echo.
-echo ---------------------------------------------------------------------------------------
-echo !!! ATTENTION !!! ATTENTION !!! ATTENTION !!! ATTENTION !!! ATTENTION !!! ATTENTION !!!
-echo.
-echo Following modifications have to be done manually in generated data contracts:
-echo  * Remove method "protected void RaisePropertyChanged(string propertyName)" in HiveItem
-echo.
-echo !!! ATTENTION !!! ATTENTION !!! ATTENTION !!! ATTENTION !!! ATTENTION !!! ATTENTION !!!
-echo ---------------------------------------------------------------------------------------
-echo.
-echo Generation of HiveService client finished.
-echo *******************************************************************************************
+SET /P HOST=Which host should be used? [services.heuristiclab.com]: 
+IF "%HOST%"=="" SET HOST=services.heuristiclab.com
 
+SET /P GENERATECONFIG=Would you like to generate the configuration file? [y]: 
+IF "%GENERATECONFIG%"=="" SET GENERATECONFIG=y
+
+SET ARGS=http://%HOST%/Hive-3.3/HiveService.svc?wsdl ^
+/out:HiveServiceClient ^
+/namespace:*,HeuristicLab.Clients.Hive ^
+/collectionType:System.Collections.Generic.List`1 ^
+/targetClientVersion:Version35 ^
+/serializable ^
+/enableDataBinding ^
+/syncOnly
+
+IF "%GENERATECONFIG%"=="y" (
+  SET ARGS=%ARGS% /config:..\app.config /mergeConfig
+) ELSE (
+  SET ARGS=%ARGS% /noConfig
+)
+
+ECHO.
+ECHO Generating HiveService client
+ECHO.
+
+SETLOCAL ENABLEDELAYEDEXPANSION
+svcutil.exe %ARGS%
+ENDLOCAL
+
+ECHO.
+ECHO ---------------------------------------------------------------------------------------
+ECHO !!! ATTENTION !!! ATTENTION !!! ATTENTION !!! ATTENTION !!! ATTENTION !!! ATTENTION !!!
+ECHO.
+ECHO Following modifications have to be done manually in generated data contracts:
+ECHO  * Remove method "protected void RaisePropertyChanged(string propertyName)" in generated HiveItem
+ECHO.
+ECHO !!! ATTENTION !!! ATTENTION !!! ATTENTION !!! ATTENTION !!! ATTENTION !!! ATTENTION !!!
+ECHO ---------------------------------------------------------------------------------------
+ECHO.
+ECHO Generation of HiveService client finished.
+ECHO *******************************************************************************************
+ECHO.
+
+PAUSE
Index: /trunk/sources/HeuristicLab.Clients.OKB/3.3/Administration/ServiceClient/GenerateServiceClient.cmd
===================================================================
--- /trunk/sources/HeuristicLab.Clients.OKB/3.3/Administration/ServiceClient/GenerateServiceClient.cmd	(revision 14725)
+++ /trunk/sources/HeuristicLab.Clients.OKB/3.3/Administration/ServiceClient/GenerateServiceClient.cmd	(revision 14726)
@@ -1,33 +1,51 @@
-echo off
+@ECHO OFF
 
-echo.
-echo *******************************************************************************************
-echo Generating OKB administration service client
-echo.
+SET HOST=
+SET GENERATECONFIG=
 
-REM If app.config should be generated, use option "/config:..\..\app.config" and optionally "/mergeConfig" instead of "/noConfig".
+ECHO.
+ECHO *******************************************************************************************
 
-svcutil.exe ^
-  http://localhost:8732/Design_Time_Addresses/OKB-3.3/AdministrationService/mex ^
-  /out:AdministrationServiceClient ^
-  /namespace:*,HeuristicLab.Clients.OKB.Administration ^
-  /collectionType:System.Collections.Generic.List`1 ^
-  /targetClientVersion:Version35 ^
-  /enableDataBinding ^
-  /noConfig
+SET /P HOST=Which host should be used? [services.heuristiclab.com]: 
+IF "%HOST%"=="" SET HOST=services.heuristiclab.com
 
-echo.
-echo ---------------------------------------------------------------------------------------
-echo !!! ATTENTION !!! ATTENTION !!! ATTENTION !!! ATTENTION !!! ATTENTION !!! ATTENTION !!!
-echo.
-echo Following modifications have to be done manually in generated data contracts:
-echo  * Remove method "protected void RaisePropertyChanged(string propertyName)" in OKBItem
-echo.
-echo !!! ATTENTION !!! ATTENTION !!! ATTENTION !!! ATTENTION !!! ATTENTION !!! ATTENTION !!!
-echo ---------------------------------------------------------------------------------------
-echo.
-echo Generation of OKB administration service client finished.
-echo *******************************************************************************************
-echo.
+SET /P GENERATECONFIG=Would you like to generate the configuration file? [y]: 
+IF "%GENERATECONFIG%"=="" SET GENERATECONFIG=y
 
-pause
+SET ARGS=http://%HOST%/OKB-3.3/AdministrationService.svc?wsdl ^
+/out:AdministrationServiceClient ^
+/namespace:*,HeuristicLab.Clients.OKB.Administration ^
+/collectionType:System.Collections.Generic.List`1 ^
+/targetClientVersion:Version35 ^
+/enableDataBinding ^
+/syncOnly
+
+IF "%GENERATECONFIG%"=="y" (
+  SET ARGS=%ARGS% /config:..\..\app.config /mergeConfig
+) ELSE (
+  SET ARGS=%ARGS% /noConfig
+)
+
+ECHO.
+ECHO Generating AdministrationService client
+ECHO.
+
+SETLOCAL ENABLEDELAYEDEXPANSION
+svcutil.exe %ARGS%
+ENDLOCAL
+
+ECHO.
+ECHO ---------------------------------------------------------------------------------------
+ECHO !!! ATTENTION !!! ATTENTION !!! ATTENTION !!! ATTENTION !!! ATTENTION !!! ATTENTION !!!
+ECHO.
+ECHO Following modifications have to be done manually in generated data contracts:
+ECHO  * Remove method "protected void RaisePropertyChanged(string propertyName)" in generated OKBItem
+ECHO.
+ECHO !!! ATTENTION !!! ATTENTION !!! ATTENTION !!! ATTENTION !!! ATTENTION !!! ATTENTION !!!
+ECHO ---------------------------------------------------------------------------------------
+ECHO.
+ECHO Generation of AdministrationService client finished.
+ECHO *******************************************************************************************
+ECHO.
+
+PAUSE
Index: /trunk/sources/HeuristicLab.Clients.OKB/3.3/Query/ServiceClient/GenerateServiceClient.cmd
===================================================================
--- /trunk/sources/HeuristicLab.Clients.OKB/3.3/Query/ServiceClient/GenerateServiceClient.cmd	(revision 14725)
+++ /trunk/sources/HeuristicLab.Clients.OKB/3.3/Query/ServiceClient/GenerateServiceClient.cmd	(revision 14726)
@@ -1,24 +1,42 @@
-echo off
+@ECHO OFF
 
-echo.
-echo *******************************************************************************************
-echo Generating OKB query service client
-echo.
+SET HOST=
+SET GENERATECONFIG=
 
-REM If app.config should be generated, use option "/config:..\..\app.config" and optionally "/mergeConfig" instead of "/noConfig".
+ECHO.
+ECHO *******************************************************************************************
 
-svcutil.exe ^
-  http://localhost:8732/Design_Time_Addresses/OKB-3.3/QueryService/mex ^
-  /out:QueryServiceClient ^
-  /namespace:*,HeuristicLab.Clients.OKB.Query ^
-  /collectionType:System.Collections.Generic.List`1 ^
-  /targetClientVersion:Version35 ^
-  /enableDataBinding ^
-  /noConfig
+SET /P HOST=Which host should be used? [services.heuristiclab.com]: 
+IF "%HOST%"=="" SET HOST=services.heuristiclab.com
 
-echo.
-echo Generation of OKB query service client finished.
-echo *******************************************************************************************
-echo.
+SET /P GENERATECONFIG=Would you like to generate the configuration file? [y]: 
+IF "%GENERATECONFIG%"=="" SET GENERATECONFIG=y
 
-pause
+SET ARGS=http://%HOST%/OKB-3.3/QueryService.svc ^
+/out:QueryServiceClient ^
+/namespace:*,HeuristicLab.Clients.OKB.Query ^
+/collectionType:System.Collections.Generic.List`1 ^
+/targetClientVersion:Version35 ^
+/enableDataBinding ^
+/syncOnly
+
+IF "%GENERATECONFIG%"=="y" (
+  SET ARGS=%ARGS% /config:..\..\app.config /mergeConfig
+) ELSE (
+  SET ARGS=%ARGS% /noConfig
+)
+
+ECHO.
+ECHO Generating QueryService client
+ECHO.
+
+SETLOCAL ENABLEDELAYEDEXPANSION
+svcutil.exe %ARGS%
+ENDLOCAL
+
+ECHO.
+ECHO Generation of QueryService client finished.
+ECHO *******************************************************************************************
+ECHO.
+
+PAUSE
Index: /trunk/sources/HeuristicLab.Clients.OKB/3.3/RunCreation/ServiceClient/GenerateServiceClient.cmd
===================================================================
--- /trunk/sources/HeuristicLab.Clients.OKB/3.3/RunCreation/ServiceClient/GenerateServiceClient.cmd	(revision 14725)
+++ /trunk/sources/HeuristicLab.Clients.OKB/3.3/RunCreation/ServiceClient/GenerateServiceClient.cmd	(revision 14726)
@@ -1,24 +1,42 @@
-echo off
+@ECHO OFF
 
-echo.
-echo *******************************************************************************************
-echo Generating OKB run creation service client
-echo.
+SET HOST=
+SET GENERATECONFIG=
 
-REM If app.config should be generated, use option "/config:..\..\app.config" and optionally "/mergeConfig" instead of "/noConfig".
+ECHO.
+ECHO *******************************************************************************************
 
-svcutil.exe ^
-  http://localhost:8732/Design_Time_Addresses/OKB-3.3/RunCreationService/mex ^
-  /out:RunCreationServiceClient ^
-  /namespace:*,HeuristicLab.Clients.OKB.RunCreation ^
-  /collectionType:System.Collections.Generic.List`1 ^
-  /targetClientVersion:Version35 ^
-  /enableDataBinding ^
-  /noConfig
+SET /P HOST=Which host should be used? [services.heuristiclab.com]: 
+IF "%HOST%"=="" SET HOST=services.heuristiclab.com
 
-echo.
-echo Generation of OKB run creation service client finished.
-echo *******************************************************************************************
-echo.
+SET /P GENERATECONFIG=Would you like to generate the configuration file? [y]: 
+IF "%GENERATECONFIG%"=="" SET GENERATECONFIG=y
 
-pause
+SET ARGS=http://%HOST%/OKB-3.3/RunCreationService.svc?wsdl ^
+/out:RunCreationServiceClient ^
+/namespace:*,HeuristicLab.Clients.OKB.RunCreation ^
+/collectionType:System.Collections.Generic.List`1 ^
+/targetClientVersion:Version35 ^
+/enableDataBinding ^
+/syncOnly
+
+IF "%GENERATECONFIG%"=="y" (
+  SET ARGS=%ARGS% /config:..\..\app.config /mergeConfig
+) ELSE (
+  SET ARGS=%ARGS% /noConfig
+)
+
+ECHO.
+ECHO Generating RunCreationService client
+ECHO.
+
+SETLOCAL ENABLEDELAYEDEXPANSION
+svcutil.exe %ARGS%
+ENDLOCAL
+
+ECHO.
+ECHO Generation of RunCreationService client finished.
+ECHO *******************************************************************************************
+ECHO.
+
+PAUSE
Index: /trunk/sources/HeuristicLab.PluginInfrastructure/3.3/Advanced/DeploymentService/GenerateServiceClients.cmd
===================================================================
--- /trunk/sources/HeuristicLab.PluginInfrastructure/3.3/Advanced/DeploymentService/GenerateServiceClients.cmd	(revision 14725)
+++ /trunk/sources/HeuristicLab.PluginInfrastructure/3.3/Advanced/DeploymentService/GenerateServiceClients.cmd	(revision 14726)
@@ -1,22 +1,40 @@
-echo off
+@ECHO OFF
 
-echo.
-echo *******************************************************************************************
-echo Generating DeploymentService clients
-echo.
+SET HOST=
+SET GENERATECONFIG=
 
-svcutil.exe ^
-  http://services.heuristiclab.com/Deployment-3.3/UpdateService.svc/mex ^
-  http://services.heuristiclab.com/Deployment-3.3/AdminService.svc/mex ^
-  /out:ServiceClients ^
-  /namespace:*,HeuristicLab.PluginInfrastructure.Advanced.DeploymentService ^
-  /targetClientVersion:Version35 ^
-  /mergeConfig ^
-  /config:..\..\app.config
+ECHO.
+ECHO *******************************************************************************************
 
-echo.
-echo Generation of DeploymentService clients finished.
-echo *******************************************************************************************
-echo.
+SET /P HOST=Which host should be used? [services.heuristiclab.com]: 
+IF "%HOST%"=="" SET HOST=services.heuristiclab.com
 
-pause
+SET /P GENERATECONFIG=Would you like to generate the configuration file? [y]: 
+IF "%GENERATECONFIG%"=="" SET GENERATECONFIG=y
+
+SET ARGS=http://%HOST%/Deployment-3.3/UpdateService.svc?wsdl http://%HOST%/Deployment-3.3/AdminService.svc?wsdl ^
+/out:ServiceClients ^
+/namespace:*,HeuristicLab.PluginInfrastructure.Advanced.DeploymentService ^
+/targetClientVersion:Version35 ^
+/syncOnly
+
+IF "%GENERATECONFIG%"=="y" (
+  SET ARGS=%ARGS% /config:..\..\app.config /mergeConfig
+) ELSE (
+  SET ARGS=%ARGS% /noConfig
+)
+
+ECHO.
+ECHO Generating UpdateService and AdminService clients
+ECHO.
+
+SETLOCAL ENABLEDELAYEDEXPANSION
+svcutil.exe %ARGS%
+ENDLOCAL
+
+ECHO.
+ECHO Generation of UpdateService and AdminService clients finished.
+ECHO *******************************************************************************************
+ECHO.
+
+PAUSE