Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Benchmark/ProblemTests.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Benchmark/ProblemTests.cs	(revision 14727)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Benchmark/ProblemTests.cs	(revision 14733)
@@ -141,6 +141,6 @@
 
       Expression bestProgram = null;
-      var config = new PushGpConfiguration { EvalPushLimit = 4096 };
-      var pool = new PushGpInterpreterPool(config);
+      var config = new PushConfiguration { EvalPushLimit = 4096 };
+      var pool = new PushInterpreterPool(config);
 
       var instance = new BenchmarkSuiteInstanceProvider();
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/ExpressionTest.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/ExpressionTest.cs	(revision 14727)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/ExpressionTest.cs	(revision 14733)
@@ -8,5 +8,5 @@
     protected PushGpInterpreter interpreter;
 
-    protected PushGpConfiguration configuration = new PushGpConfiguration { TopLevelPushCode = false };
+    protected PushConfiguration configuration = new PushConfiguration { TopLevelPushCode = false };
 
     [TestInitialize]
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/CodeExpressionTests.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/CodeExpressionTests.cs	(revision 14727)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/CodeExpressionTests.cs	(revision 14733)
@@ -29,7 +29,7 @@
     [TestCategory("CodeExpressionTest")]
     public void TestAppendLists() {
-      var first = PushGPParser.Parse("( A )");
-      var second = PushGPParser.Parse("( B )");
-      var result = PushGPParser.Parse("( A B )");
+      var first = PushParser.Parse("( A )");
+      var second = PushParser.Parse("( B )");
+      var result = PushParser.Parse("( A B )");
 
       this.interpreter.CodeStack.Push(second, first);
@@ -45,7 +45,7 @@
     [TestCategory("CodeExpressionTest")]
     public void TestAppendListAndLiteral() {
-      var first = PushGPParser.Parse("( A )");
-      var second = PushGPParser.Parse("5");
-      var result = PushGPParser.Parse("( A 5 )");
+      var first = PushParser.Parse("( A )");
+      var second = PushParser.Parse("5");
+      var result = PushParser.Parse("( A 5 )");
 
       this.interpreter.CodeStack.Push(second, first);
@@ -61,7 +61,7 @@
     [TestCategory("CodeExpressionTest")]
     public void TestAppendLiterals() {
-      var first = PushGPParser.Parse("4");
-      var second = PushGPParser.Parse("5");
-      var result = PushGPParser.Parse("( 4 5 )");
+      var first = PushParser.Parse("4");
+      var second = PushParser.Parse("5");
+      var result = PushParser.Parse("( 4 5 )");
 
       this.interpreter.CodeStack.Push(second, first);
@@ -77,6 +77,6 @@
     [TestCategory("CodeExpressionTest")]
     public void TestDuplicateList() {
-      var list = PushGPParser.Parse("( A B C )");
-      var result = PushGPParser.Parse("( A B C )");
+      var list = PushParser.Parse("( A B C )");
+      var result = PushParser.Parse("( A B C )");
 
       this.interpreter.CodeStack.Push(list);
@@ -95,5 +95,5 @@
     [TestCategory("CodeExpressionTest")]
     public void TestAtomList() {
-      var first = PushGPParser.Parse("( A )");
+      var first = PushParser.Parse("( A )");
 
       this.interpreter.CodeStack.Push(first);
@@ -109,5 +109,5 @@
     [TestCategory("CodeExpressionTest")]
     public void TestAtomLiteral() {
-      var first = PushGPParser.Parse("5");
+      var first = PushParser.Parse("5");
 
       this.interpreter.CodeStack.Push(first);
@@ -123,5 +123,5 @@
     [TestCategory("CodeExpressionTest")]
     public void TestAtomSingleInstruction() {
-      var first = PushGPParser.Parse("INTEGER.+");
+      var first = PushParser.Parse("INTEGER.+");
 
       this.interpreter.CodeStack.Push(first);
@@ -137,6 +137,6 @@
     [TestCategory("CodeExpressionTest")]
     public void TestCarList() {
-      var first = PushGPParser.Parse("( A B C )");
-      var result = PushGPParser.Parse("A");
+      var first = PushParser.Parse("( A B C )");
+      var result = PushParser.Parse("A");
 
       this.interpreter.CodeStack.Push(first);
@@ -152,6 +152,6 @@
     [TestCategory("CodeExpressionTest")]
     public void TestCarNoList() {
-      var first = PushGPParser.Parse("5");
-      var result = PushGPParser.Parse("5");
+      var first = PushParser.Parse("5");
+      var result = PushParser.Parse("5");
 
       this.interpreter.CodeStack.Push(first);
@@ -167,6 +167,6 @@
     [TestCategory("CodeExpressionTest")]
     public void TestCdrList() {
-      var first = PushGPParser.Parse("( A B C )");
-      var result = PushGPParser.Parse("( B C )");
+      var first = PushParser.Parse("( A B C )");
+      var result = PushParser.Parse("( B C )");
 
       this.interpreter.CodeStack.Push(first);
@@ -182,6 +182,6 @@
     [TestCategory("CodeExpressionTest")]
     public void TestCdrNoList() {
-      var first = PushGPParser.Parse("5");
-      var result = PushGPParser.Parse("( )");
+      var first = PushParser.Parse("5");
+      var result = PushParser.Parse("( )");
 
       this.interpreter.CodeStack.Push(first);
@@ -197,7 +197,7 @@
     [TestCategory("CodeExpressionTest")]
     public void TestCons() {
-      var first = PushGPParser.Parse("( B C )");
-      var second = PushGPParser.Parse("A");
-      var result = PushGPParser.Parse("( A B C )");
+      var first = PushParser.Parse("( B C )");
+      var second = PushParser.Parse("A");
+      var result = PushParser.Parse("( A B C )");
 
       this.interpreter.CodeStack.Push(second, first);
@@ -213,6 +213,6 @@
     [TestCategory("CodeExpressionTest")]
     public void TestContainsTrue() {
-      var first = PushGPParser.Parse("A");
-      var second = PushGPParser.Parse("( A B C )");
+      var first = PushParser.Parse("A");
+      var second = PushParser.Parse("( A B C )");
 
       this.interpreter.CodeStack.Push(second, first);
@@ -228,6 +228,6 @@
     [TestCategory("CodeExpressionTest")]
     public void TestContainsFalse() {
-      var first = PushGPParser.Parse("D");
-      var second = PushGPParser.Parse("( A B C )");
+      var first = PushParser.Parse("D");
+      var second = PushParser.Parse("( A B C )");
 
       this.interpreter.CodeStack.Push(second, first);
@@ -243,7 +243,7 @@
     [TestCategory("CodeExpressionTest")]
     public void TestContainer() {
-      var first = PushGPParser.Parse("( A )");
-      var second = PushGPParser.Parse("( B ( C ( A ) ) ( D ( A ) ) )");
-      var result = PushGPParser.Parse("( C ( A ) )");
+      var first = PushParser.Parse("( A )");
+      var second = PushParser.Parse("( B ( C ( A ) ) ( D ( A ) ) )");
+      var result = PushParser.Parse("( C ( A ) )");
 
       this.interpreter.CodeStack.Push(second, first);
@@ -259,5 +259,5 @@
     [TestCategory("CodeExpressionTest")]
     public void TestDefinition() {
-      var code = PushGPParser.Parse("( A )");
+      var code = PushParser.Parse("( A )");
 
       this.interpreter.CustomExpressions.Add("Test", code);
@@ -275,5 +275,5 @@
     [TestCategory("CodeExpressionTest")]
     public void TestDefinitionWithoutMatchingName() {
-      var code = PushGPParser.Parse("( A )");
+      var code = PushParser.Parse("( A )");
       var program = new CodeDefinitionExpression();
 
@@ -290,6 +290,6 @@
     [TestCategory("CodeExpressionTest")]
     public void TestDiscrepancy() {
-      var first = PushGPParser.Parse("( A B )");
-      var second = PushGPParser.Parse("( B C )");
+      var first = PushParser.Parse("( A B )");
+      var second = PushParser.Parse("( B C )");
 
       this.interpreter.CodeStack.Push(second, first);
@@ -305,6 +305,6 @@
     [TestCategory("CodeExpressionTest")]
     public void TestDiscrepancyAllEqual() {
-      var first = PushGPParser.Parse("( A B )");
-      var second = PushGPParser.Parse("( B A )");
+      var first = PushParser.Parse("( A B )");
+      var second = PushParser.Parse("( B A )");
 
       this.interpreter.CodeStack.Push(second, first);
@@ -320,6 +320,6 @@
     [TestCategory("CodeExpressionTest")]
     public void TestDiscrepancyComplex() {
-      var first = PushGPParser.Parse("( A A B C D A )");
-      var second = PushGPParser.Parse("( A A B D E )");
+      var first = PushParser.Parse("( A A B C D A )");
+      var second = PushParser.Parse("( A A B D E )");
 
       this.interpreter.CodeStack.Push(second, first);
@@ -335,6 +335,6 @@
     [TestCategory("CodeExpressionTest")]
     public void TestDiscrepancWithLists() {
-      var first = PushGPParser.Parse("( ( A ) A ( B ) C D A )");
-      var second = PushGPParser.Parse("( A ( A ) B D E )");
+      var first = PushParser.Parse("( ( A ) A ( B ) C D A )");
+      var second = PushParser.Parse("( A ( A ) B D E )");
 
       this.interpreter.CodeStack.Push(second, first);
@@ -350,5 +350,5 @@
     [TestCategory("CodeExpressionTest")]
     public void TestDo() {
-      var prog = PushGPParser.Parse("( 10 )");
+      var prog = PushParser.Parse("( 10 )");
 
       this.interpreter.CodeStack.Push(prog);
@@ -364,5 +364,5 @@
     [TestCategory("CodeExpressionTest")]
     public void TestDoX() {
-      var prog = PushGPParser.Parse("( 10 )");
+      var prog = PushParser.Parse("( 10 )");
 
       this.interpreter.CodeStack.Push(prog);
@@ -378,5 +378,5 @@
     [TestCategory("CodeExpressionTest")]
     public void TestDoCount() {
-      var prog = PushGPParser.Parse("INTEGER.+");
+      var prog = PushParser.Parse("INTEGER.+");
 
       this.interpreter.IntegerStack.Push(3);
@@ -393,5 +393,5 @@
     [TestCategory("CodeExpressionTest")]
     public void TestDoCountWithNegativeCounter() {
-      var prog = PushGPParser.Parse("INTEGER.+");
+      var prog = PushParser.Parse("INTEGER.+");
 
       this.interpreter.IntegerStack.Push(-1);
@@ -408,5 +408,5 @@
     [TestCategory("CodeExpressionTest")]
     public void TestDoRange() {
-      var prog = PushGPParser.Parse("INTEGER.+");
+      var prog = PushParser.Parse("INTEGER.+");
 
       this.interpreter.IntegerStack.Push(3, 5);
@@ -423,5 +423,5 @@
     [TestCategory("CodeExpressionTest")]
     public void TestDoRangeWithEqualIndecators() {
-      var prog = PushGPParser.Parse("INTEGER.+");
+      var prog = PushParser.Parse("INTEGER.+");
 
       this.interpreter.IntegerStack.Push(3, 3);
@@ -438,5 +438,5 @@
     [TestCategory("CodeExpressionTest")]
     public void TestDoRangeWithNegativeIndecators() {
-      var prog = PushGPParser.Parse("INTEGER.+");
+      var prog = PushParser.Parse("INTEGER.+");
 
       this.interpreter.IntegerStack.Push(-3, -5);
@@ -453,5 +453,5 @@
     [TestCategory("CodeExpressionTest")]
     public void TestDoTimes() {
-      var prog = PushGPParser.Parse("( INTEGER.DUP INTEGER.+ )");
+      var prog = PushParser.Parse("( INTEGER.DUP INTEGER.+ )");
 
       this.interpreter.IntegerStack.Push(2, 3);
@@ -468,5 +468,5 @@
     [TestCategory("CodeExpressionTest")]
     public void TestDoTimesWithNegativeCounter() {
-      var prog = PushGPParser.Parse("( INTEGER.DUP INTEGER.+ )");
+      var prog = PushParser.Parse("( INTEGER.DUP INTEGER.+ )");
 
       this.interpreter.IntegerStack.Push(2, -3);
@@ -519,6 +519,6 @@
     [TestCategory("CodeExpressionTest")]
     public void TestExtract() {
-      var prog = PushGPParser.Parse("( A ( B C ( D ) E ) F G H I J ( K ) L )");
-      var result = PushGPParser.Parse("( D )");
+      var prog = PushParser.Parse("( A ( B C ( D ) E ) F G H I J ( K ) L )");
+      var result = PushParser.Parse("( D )");
 
       this.interpreter.IntegerStack.Push(5);
@@ -535,6 +535,6 @@
     [TestCategory("CodeExpressionTest")]
     public void TestExtractInteger() {
-      var prog = PushGPParser.Parse("( A ( 5 C ( 4.2 ) INTEGER.+ ) FALSE )");
-      var result = PushGPParser.Parse("5");
+      var prog = PushParser.Parse("( A ( 5 C ( 4.2 ) INTEGER.+ ) FALSE )");
+      var result = PushParser.Parse("5");
 
       this.interpreter.IntegerStack.Push(3);
@@ -551,6 +551,6 @@
     [TestCategory("CodeExpressionTest")]
     public void TestExtractFloat() {
-      var prog = PushGPParser.Parse("( A ( 5 C ( 4.2 ) INTEGER.+ ) FALSE )");
-      var result = PushGPParser.Parse("4.2");
+      var prog = PushParser.Parse("( A ( 5 C ( 4.2 ) INTEGER.+ ) FALSE )");
+      var result = PushParser.Parse("4.2");
 
       this.interpreter.IntegerStack.Push(6);
@@ -567,6 +567,6 @@
     [TestCategory("CodeExpressionTest")]
     public void TestExtractBoolean() {
-      var prog = PushGPParser.Parse("( A ( 5 C ( 4.2 ) INTEGER.+ ) FALSE )");
-      var result = PushGPParser.Parse("FALSE");
+      var prog = PushParser.Parse("( A ( 5 C ( 4.2 ) INTEGER.+ ) FALSE )");
+      var result = PushParser.Parse("FALSE");
 
       this.interpreter.IntegerStack.Push(8);
@@ -583,6 +583,6 @@
     [TestCategory("CodeExpressionTest")]
     public void TestExtractInstruction() {
-      var prog = PushGPParser.Parse("( A ( 5 C ( 4.2 ) INTEGER.+ ) FALSE )");
-      var result = PushGPParser.Parse("INTEGER.+");
+      var prog = PushParser.Parse("( A ( 5 C ( 4.2 ) INTEGER.+ ) FALSE )");
+      var result = PushParser.Parse("INTEGER.+");
 
       this.interpreter.IntegerStack.Push(7);
@@ -599,5 +599,5 @@
     [TestCategory("CodeExpressionTest")]
     public void TestFromBoolean() {
-      var result = PushGPParser.Parse("FALSE");
+      var result = PushParser.Parse("FALSE");
       this.interpreter.BooleanStack.Push(false);
       this.interpreter.Run(new CodeFromBooleanExpression());
@@ -612,5 +612,5 @@
     [TestCategory("CodeExpressionTest")]
     public void TestFromFloat() {
-      var result = PushGPParser.Parse("4.1");
+      var result = PushParser.Parse("4.1");
       this.interpreter.FloatStack.Push(4.1);
       this.interpreter.Run(new CodeFromFloatExpression());
@@ -625,5 +625,5 @@
     [TestCategory("CodeExpressionTest")]
     public void TestFromInteger() {
-      var result = PushGPParser.Parse("4");
+      var result = PushParser.Parse("4");
       this.interpreter.IntegerStack.Push(4);
       this.interpreter.Run(new CodeFromIntegerExpression());
@@ -638,5 +638,5 @@
     [TestCategory("CodeExpressionTest")]
     public void TestFromName() {
-      var result = PushGPParser.Parse("A");
+      var result = PushParser.Parse("A");
       this.interpreter.NameStack.Push("A");
       this.interpreter.Run(new CodeFromNameExpression());
@@ -651,6 +651,6 @@
     [TestCategory("CodeExpressionTest")]
     public void TestIfTrue() {
-      var first = PushGPParser.Parse("FALSCH");
-      var second = PushGPParser.Parse("WAHR");
+      var first = PushParser.Parse("FALSCH");
+      var second = PushParser.Parse("WAHR");
 
       this.interpreter.BooleanStack.Push(true);
@@ -667,6 +667,6 @@
     [TestCategory("CodeExpressionTest")]
     public void TestIfFalse() {
-      var first = PushGPParser.Parse("FALSCH");
-      var second = PushGPParser.Parse("WAHR");
+      var first = PushParser.Parse("FALSCH");
+      var second = PushParser.Parse("WAHR");
 
       this.interpreter.BooleanStack.Push(false);
@@ -683,7 +683,7 @@
     [TestCategory("CodeExpressionTest")]
     public void TestInsert() {
-      var first = PushGPParser.Parse("( A ( B ) C D )");
-      var second = PushGPParser.Parse("( E )");
-      var result = PushGPParser.Parse("( A ( B ) ( E ) D )");
+      var first = PushParser.Parse("( A ( B ) C D )");
+      var second = PushParser.Parse("( E )");
+      var result = PushParser.Parse("( A ( B ) ( E ) D )");
 
       this.interpreter.IntegerStack.Push(2);
@@ -700,7 +700,7 @@
     [TestCategory("CodeExpressionTest")]
     public void TestInsertWithNegativeN() {
-      var first = PushGPParser.Parse("( A ( B ) C D )");
-      var second = PushGPParser.Parse("( E )");
-      var result = PushGPParser.Parse("( A ( B ) ( E ) D )");
+      var first = PushParser.Parse("( A ( B ) C D )");
+      var second = PushParser.Parse("( E )");
+      var result = PushParser.Parse("( A ( B ) ( E ) D )");
 
       this.interpreter.IntegerStack.Push(-2);
@@ -717,7 +717,7 @@
     [TestCategory("CodeExpressionTest")]
     public void TestInsertWithTooBigN() {
-      var first = PushGPParser.Parse("( A ( B ) C D )");
-      var second = PushGPParser.Parse("( E )");
-      var result = PushGPParser.Parse("( A ( B ) ( E ) D )");
+      var first = PushParser.Parse("( A ( B ) C D )");
+      var second = PushParser.Parse("( E )");
+      var result = PushParser.Parse("( A ( B ) ( E ) D )");
 
       this.interpreter.IntegerStack.Push(10);
@@ -734,7 +734,7 @@
     [TestCategory("CodeExpressionTest")]
     public void TestList() {
-      var first = PushGPParser.Parse("A");
-      var second = PushGPParser.Parse("( B )");
-      var result = PushGPParser.Parse("( A ( B ) )");
+      var first = PushParser.Parse("A");
+      var second = PushParser.Parse("( B )");
+      var result = PushParser.Parse("( A ( B ) )");
 
       this.interpreter.CodeStack.Push(second, first);
@@ -750,6 +750,6 @@
     [TestCategory("CodeExpressionTest")]
     public void TestMemberTrue() {
-      var first = PushGPParser.Parse("( A B ( B ) C ");
-      var second = PushGPParser.Parse("( B )");
+      var first = PushParser.Parse("( A B ( B ) C ");
+      var second = PushParser.Parse("( B )");
 
       this.interpreter.CodeStack.Push(second, first);
@@ -765,6 +765,6 @@
     [TestCategory("CodeExpressionTest")]
     public void TestMemberFalse() {
-      var first = PushGPParser.Parse("( A B C ");
-      var second = PushGPParser.Parse("( B )");
+      var first = PushParser.Parse("( A B C ");
+      var second = PushParser.Parse("( B )");
 
       this.interpreter.CodeStack.Push(second, first);
@@ -780,6 +780,6 @@
     [TestCategory("CodeExpressionTest")]
     public void TestMemberIfNoList() {
-      var first = PushGPParser.Parse("B");
-      var second = PushGPParser.Parse("B");
+      var first = PushParser.Parse("B");
+      var second = PushParser.Parse("B");
 
       this.interpreter.CodeStack.Push(second, first);
@@ -805,6 +805,6 @@
     [TestCategory("CodeExpressionTest")]
     public void TestNthIfNoList() {
-      var prog = PushGPParser.Parse("A");
-      var result = PushGPParser.Parse("A");
+      var prog = PushParser.Parse("A");
+      var result = PushParser.Parse("A");
 
       this.interpreter.IntegerStack.Push(3);
@@ -821,6 +821,6 @@
     [TestCategory("CodeExpressionTest")]
     public void TestNthIfEmpty() {
-      var prog = PushGPParser.Parse("( )");
-      var result = PushGPParser.Parse("( )");
+      var prog = PushParser.Parse("( )");
+      var result = PushParser.Parse("( )");
 
       this.interpreter.IntegerStack.Push(3);
@@ -837,6 +837,6 @@
     [TestCategory("CodeExpressionTest")]
     public void TestNth() {
-      var prog = PushGPParser.Parse("( A B C D E )");
-      var result = PushGPParser.Parse("D");
+      var prog = PushParser.Parse("( A B C D E )");
+      var result = PushParser.Parse("D");
 
       this.interpreter.IntegerStack.Push(3);
@@ -853,6 +853,6 @@
     [TestCategory("CodeExpressionTest")]
     public void TestNthWithTooBigN() {
-      var prog = PushGPParser.Parse("( A B C D E )");
-      var result = PushGPParser.Parse("D");
+      var prog = PushParser.Parse("( A B C D E )");
+      var result = PushParser.Parse("D");
 
       this.interpreter.IntegerStack.Push(13);
@@ -869,6 +869,6 @@
     [TestCategory("CodeExpressionTest")]
     public void TestNthWithNegativeN() {
-      var prog = PushGPParser.Parse("( A B C D E )");
-      var result = PushGPParser.Parse("D");
+      var prog = PushParser.Parse("( A B C D E )");
+      var result = PushParser.Parse("D");
 
       this.interpreter.IntegerStack.Push(-3);
@@ -885,6 +885,6 @@
     [TestCategory("CodeExpressionTest")]
     public void TestNthCdr() {
-      var prog = PushGPParser.Parse("( A B C D E )");
-      var result = PushGPParser.Parse("D");
+      var prog = PushParser.Parse("( A B C D E )");
+      var result = PushParser.Parse("D");
 
       this.interpreter.IntegerStack.Push(2);
@@ -901,6 +901,6 @@
     [TestCategory("CodeExpressionTest")]
     public void TestNthCdrWithTooBigN() {
-      var prog = PushGPParser.Parse("( A B C D E )");
-      var result = PushGPParser.Parse("D");
+      var prog = PushParser.Parse("( A B C D E )");
+      var result = PushParser.Parse("D");
 
       this.interpreter.IntegerStack.Push(10);
@@ -917,6 +917,6 @@
     [TestCategory("CodeExpressionTest")]
     public void TestNthCdrWithNegativeN() {
-      var prog = PushGPParser.Parse("( A B C D E )");
-      var result = PushGPParser.Parse("D");
+      var prog = PushParser.Parse("( A B C D E )");
+      var result = PushParser.Parse("D");
 
       this.interpreter.IntegerStack.Push(-2);
@@ -933,6 +933,6 @@
     [TestCategory("CodeExpressionTest")]
     public void TestNthCdrIfEmpty() {
-      var prog = PushGPParser.Parse("( )");
-      var result = PushGPParser.Parse("( )");
+      var prog = PushParser.Parse("( )");
+      var result = PushParser.Parse("( )");
 
       this.interpreter.IntegerStack.Push(3);
@@ -949,6 +949,6 @@
     [TestCategory("CodeExpressionTest")]
     public void TestNthCdrIfNoList() {
-      var prog = PushGPParser.Parse("A");
-      var result = PushGPParser.Parse("A");
+      var prog = PushParser.Parse("A");
+      var result = PushParser.Parse("A");
 
       this.interpreter.IntegerStack.Push(3);
@@ -965,5 +965,5 @@
     [TestCategory("CodeExpressionTest")]
     public void TestNullTrue() {
-      var prog = PushGPParser.Parse("( )");
+      var prog = PushParser.Parse("( )");
 
       this.interpreter.CodeStack.Push(prog);
@@ -979,5 +979,5 @@
     [TestCategory("CodeExpressionTest")]
     public void TestNullFalse() {
-      var prog = PushGPParser.Parse("A");
+      var prog = PushParser.Parse("A");
 
       this.interpreter.CodeStack.Push(prog);
@@ -993,6 +993,6 @@
     [TestCategory("CodeExpressionTest")]
     public void TestPosition() {
-      var first = PushGPParser.Parse("( A B C D )");
-      var second = PushGPParser.Parse("C");
+      var first = PushParser.Parse("( A B C D )");
+      var second = PushParser.Parse("C");
 
       this.interpreter.CodeStack.Push(second, first);
@@ -1008,5 +1008,5 @@
     [TestCategory("CodeExpressionTest")]
     public void TestQuote() {
-      var result = PushGPParser.Parse("A");
+      var result = PushParser.Parse("A");
 
       this.interpreter.Run("( CODE.QUOTE A )");
@@ -1021,5 +1021,5 @@
     [TestCategory("CodeExpressionTest")]
     public void TestSize() {
-      var prog = PushGPParser.Parse("( A ( B ( C ) ) ( D ) INTEGER.+ )");
+      var prog = PushParser.Parse("( A ( B ( C ) ) ( D ) INTEGER.+ )");
 
       this.interpreter.CodeStack.Push(prog);
@@ -1035,8 +1035,8 @@
     [TestCategory("CodeExpressionTest")]
     public void TestSubstitude() {
-      var first = PushGPParser.Parse("( A B C D A B C D )");
-      var second = PushGPParser.Parse("E");
-      var third = PushGPParser.Parse("A");
-      var result = PushGPParser.Parse("( E B C D E B C D )");
+      var first = PushParser.Parse("( A B C D A B C D )");
+      var second = PushParser.Parse("E");
+      var third = PushParser.Parse("A");
+      var result = PushParser.Parse("( E B C D E B C D )");
 
       this.interpreter.CodeStack.Push(third, second, first);
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/ExampleTests.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/ExampleTests.cs	(revision 14727)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/ExampleTests.cs	(revision 14733)
@@ -159,5 +159,5 @@
     [TestCategory("ExampleTest")]
     public void Example11() {
-      var program = PushGPParser.Parse("( INTEGER.= CODE.QUOTE FLOAT.* CODE.QUOTE FLOAT./ CODE.IF )");
+      var program = PushParser.Parse("( INTEGER.= CODE.QUOTE FLOAT.* CODE.QUOTE FLOAT./ CODE.IF )");
 
       this.interpreter.IntegerStack.Push(1, 1);
@@ -190,5 +190,5 @@
     [TestCategory("ExampleTest")]
     public void Example12() {
-      var program = PushGPParser.Parse("( INTEGER.= EXEC.IF FLOAT.* FLOAT./ )");
+      var program = PushParser.Parse("( INTEGER.= EXEC.IF FLOAT.* FLOAT./ )");
 
       this.interpreter.IntegerStack.Push(1, 1);
@@ -274,5 +274,5 @@
     [TestCategory("ExampleTest")]
     public void Example16() {
-      var list = PushGPParser.Parse("( A B C )");
+      var list = PushParser.Parse("( A B C )");
 
       this.interpreter.CodeStack.Push(list);
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/ExecExpressionTests.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/ExecExpressionTests.cs	(revision 14727)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/ExecExpressionTests.cs	(revision 14733)
@@ -57,7 +57,7 @@
     [TestCategory("ExecExpressionTest")]
     public void TestK() {
-      var first = PushGPParser.Parse("A");
-      var second = PushGPParser.Parse("B");
-      var third = PushGPParser.Parse("C");
+      var first = PushParser.Parse("A");
+      var second = PushParser.Parse("B");
+      var third = PushParser.Parse("C");
 
       this.interpreter.ExecStack.Push(third, second, first);
@@ -74,8 +74,8 @@
     [TestCategory("ExecExpressionTest")]
     public void TestS() {
-      var first = PushGPParser.Parse("A");
-      var second = PushGPParser.Parse("B");
-      var third = PushGPParser.Parse("C");
-      var result = PushGPParser.Parse("( B C )");
+      var first = PushParser.Parse("A");
+      var second = PushParser.Parse("B");
+      var third = PushParser.Parse("C");
+      var result = PushParser.Parse("( B C )");
 
       this.interpreter.ExecStack.Push(third, second, first);
@@ -93,6 +93,6 @@
     [TestCategory("ExecExpressionTest")]
     public void TestY() {
-      var first = PushGPParser.Parse("A");
-      var result = PushGPParser.Parse("( EXEC.Y A )");
+      var first = PushParser.Parse("A");
+      var result = PushParser.Parse("( EXEC.Y A )");
 
       this.interpreter.ExecStack.Push(first);
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/StandardTests.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/StandardTests.cs	(revision 14727)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/StandardTests.cs	(revision 14733)
@@ -38,5 +38,5 @@
     [TestMethod]
     public void TestExpandGetHashCode() {
-      var expand = PushGPParser.Parse("( A B C D E F )");
+      var expand = PushParser.Parse("( A B C D E F )");
 
       expand.GetHashCode();